/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;
import com.singularsys.jep.Jep;
import gui.theFrame;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
/**
 *
 * @author pchr
 */
public class FunctionParser {
    String FunctionString;
    Jep jep;
    double totalTime;
    double timestep;
    theFrame theESDOF;
    
    // constructor
    public FunctionParser(theFrame theESDOF){
        this.theESDOF=theESDOF;
    }
    
    // methods
    public void ParseFunction(){
        int from=theESDOF.LoadReader();
        if(from==0){
            FunctionString=theESDOF.getFunction();
            totalTime=theESDOF.getTotalTime();
            timestep=theESDOF.getTimeStep();
        }else{
            timestep=theESDOF.getTimeStep();
        }
        
    }
    
    public void setFunction(){
        int from=theESDOF.LoadReader();
        if(from==0){
            this.setFunctionAnalytic();
        }else{
            this.setFunctionFile();
        }
    }
    
    public void setTime(){
        int from=theESDOF.LoadReader();
        if(from==0){
            this.setTimeAnalytic();
        }else{
            this.setTimeFile();
        }
    }
    
    public void setFunctionFile(){
        double[] f = new double[0];
        File theFile=theESDOF.getInFile();
        try {
            BufferedReader in = new BufferedReader(new FileReader(theFile.getPath()));
            String str;
            int n=0;
            while ((str = in.readLine()) != null) {
                ++n;
            }
            in.close();
            in = new BufferedReader(new FileReader(theFile.getPath()));
            f = new double[n];
            n=0;
            while ((str = in.readLine()) != null) {
                f[n]=Double.parseDouble(str);
                ++n;
            }
            in.close();
        } catch (IOException e) {
        }
        theESDOF.getSdofOscillator().setFext(f);
    }
    
    public void setFunctionAnalytic(){
        int steps = (int) Math.round(totalTime/timestep)+1;
        double[] f = new double[steps];
        double t=0.0;
        jep = new Jep();
        jep.getFunctionTable().addFunction("h", new Heaviside());
        int j=0;
        for(int i=0; i<steps ; i++){
            ++j;
            if(j>50){
                j=0;
                jep = new Jep();
                jep.getFunctionTable().addFunction("h", new Heaviside());
            }
            t=i*timestep;
            jep.addVariable("t",t);
            try {
                jep.parse(FunctionString);
                double result = jep.evaluateD();
                // If the evaluation succeeds, the result will be saved
                f[i]=result;
            } catch (Exception e) {
                // If an exception is thrown while parsing or evaluating
                // information about the error is printed here
                System.out.println("An error occured: " + e.getMessage());
            }
            
        }
        theESDOF.getSdofOscillator().setFext(f);
    }
    
    public void setTimeAnalytic(){
        int steps = (int) Math.round(totalTime/timestep)+1;
        double[] t = new double[steps];
        double t0=0.;
        for(int i=0; i<steps; i++){
            t[i]=t0;
            t0+=timestep;
        }
        theESDOF.getSdofOscillator().setTime(t);
    }
    
    public void setTimeFile(){
        int steps = theESDOF.getSdofOscillator().getFext().length;
        double[] t = new double[steps];
        double t0=0.;
        for(int i=0; i<steps; i++){
            t[i]=t0;
            t0+=timestep;
        }
        theESDOF.getSdofOscillator().setTime(t);
    }

}
