/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import javax.swing.JPanel;

/**
 *
 * @author pchr
 */
public class DrawPanel extends JPanel{
    private int xs,ys,xe,ye,xm,ym;
    private AffineTransform at;
    private double xscale,yscale;
    private theFrame toFrame;
    private double[] xvar;
    private double[] yvar;
    int xind;
    int yind;
    
    public DrawPanel(){}
    
    public void plot(){
        repaint();
    }
    
    @Override
    public void paintComponent(Graphics g) {
        //System.out.println("paintComponent");
	// Define graphics
        Graphics2D g2 = (Graphics2D) g;
        // Get dimensions
	//g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
	g2.setBackground(Color.WHITE);
	g2.clearRect(0, 0, width, height);
        
        xm=width/2;
        xs=width/20;
        xe=width-width/20;
        ym=height/2;
        ys=height/20;
        ye=height-height/20;
        
        if(toFrame.getOscillator()!=null && toFrame.getOscillator().IsAnalysed()){
            xind=toFrame.getXindex();
            yind=toFrame.getYindex();
            xvar=toFrame.getOscillator().getHistory(xind);
            yvar=toFrame.getOscillator().getHistory(yind);
            
            double minx=this.getMin(xvar);
            double miny=this.getMin(yvar);
            double maxx=this.getMax(xvar);
            double maxy=this.getMax(yvar);

            if(xind!=0 && yind!=0){
                this.yscale=Math.min(Math.abs(ys-ye)/(2*Math.abs(maxy)),Math.abs(ys-ye)/(2*Math.abs(miny)));
                this.xscale=Math.min(Math.abs(xs-xe)/(2*Math.abs(maxx)),Math.abs(xs-xe)/(2*Math.abs(minx)));
                at = new AffineTransform();
                at.translate(xm, ym);
                at.rotate(Math.PI);
                at.scale(xscale, yscale);                
            }else if(xind==0 && yind!=0){
                this.yscale=Math.min(Math.abs(ys-ye)/(2*Math.abs(maxy)),Math.abs(ys-ye)/(2*Math.abs(miny)));
                this.xscale=Math.abs(xs-xe)/(Math.abs(maxx-minx));
                at = new AffineTransform();
                at.translate(xs, ym);
                at.rotate(Math.PI);
                at.scale(xscale, yscale); 
            }else if(xind!=0 && yind==0){
                this.yscale=Math.abs(ys-ye)/(Math.abs(maxy-miny));
                this.xscale=Math.min(Math.abs(xs-xe)/(2*Math.abs(maxx)),Math.abs(xs-xe)/(2*Math.abs(minx)));
                at = new AffineTransform();
                at.translate(xm, ye);
                at.rotate(Math.PI);
                at.scale(xscale, yscale);
            }else if(xind==0 && yind==0){
                this.yscale=Math.abs(ys-ye)/(Math.abs(maxy-miny));
                this.xscale=Math.abs(xs-xe)/(Math.abs(maxx-minx));
                at = new AffineTransform();
                at.translate(xs, ye);
                at.rotate(Math.PI);
                at.scale(xscale, yscale);                
            }
            
            
            g2.drawLine(xs, ye, xe, ye);
            g2.drawLine(xs, ye, xs, ys);
            //g2.drawLine(xe, ye, xe-Math.abs(xe-xs)/100, ye+Math.abs(xe-xs)/100);
            //g2.drawLine(xe, ye, xe-Math.abs(xe-xs)/100, ye-Math.abs(xe-xs)/100);
            g2.drawString(toFrame.getXparameter(), xe-Math.abs(xe-xs)/20, ye+Math.abs(ye-ys)/40);
            //g2.drawLine(xs, ys, xs-Math.abs(xe-xs)/100, ys+Math.abs(xe-xs)/100);
            //g2.drawLine(xs, ys, xs+Math.abs(xe-xs)/100, ys+Math.abs(xe-xs)/100);
            g2.drawString(toFrame.getYparameter(), xs-Math.abs(xe-xs)/20, ys-Math.abs(ye-ys)/40);
            
            int grstep=100;
            int count=0;
            DecimalFormatSymbols comma =new DecimalFormatSymbols();
            comma.setDecimalSeparator('.');
            DecimalFormat Places = new DecimalFormat("0.000E0",comma);
            String sd;
            g2.setColor(Color.RED);
            sd=Places.format(miny);
            g2.drawString(sd, 0, ye);
            sd=Places.format(minx);
            g2.drawString(sd, xs, height);
            for(int i=1;i<=grstep;i++){
                ++count;
                if (count==grstep/10){
                   g2.setColor(Color.RED);
                   sd=Places.format(miny+i*Math.abs(maxy-miny)/grstep);
                   g2.drawString(sd, 0, ye-i*Math.abs(ye-ys)/grstep);
                   sd=Places.format(minx+i*Math.abs(maxx-minx)/grstep);
                   g2.drawString(sd, xs+i*Math.abs(xe-xs)/grstep, height);
                   g2.setColor(Color.DARK_GRAY);
                   count=0;
                }else{g2.setColor(Color.LIGHT_GRAY);}
                g2.drawLine(xs+i*Math.abs(xe-xs)/grstep, ye, xs+i*Math.abs(xe-xs)/grstep, ys);
                g2.drawLine(xs, ye-i*Math.abs(ye-ys)/grstep, xe, ye-i*Math.abs(ye-ys)/grstep);
            }
            
            int x1,x2,y1,y2;
            Point2D.Double pointb,pointa;
            for(int i=0;i<xvar.length-1;i++){
                pointa = new Point2D.Double();
                pointb = new Point2D.Double(xvar[i],yvar[i]);
                at.transform(pointb, pointa);

                x1=(int) pointa.getX(); x1=mirrorX(x1);
                y1=(int) pointa.getY(); 

                pointb = new Point2D.Double(xvar[i+1],yvar[i+1]);
                at.transform(pointb, pointa);

                x2=(int) pointa.getX(); x2=mirrorX(x2);
                y2=(int) pointa.getY();
                
                g2.setColor(Color.BLUE);
                g2.drawLine(x1, y1, x2, y2);
            }
            g2.setColor(Color.BLACK);
            
        }else{
            g2.drawLine(xs, ym, xe, ym);
            g2.drawLine(xm, ys, xm, ye);
            g2.drawLine(xe, ym, xe-Math.abs(xe-xs)/100, ym+Math.abs(xe-xs)/100);
            g2.drawLine(xe, ym, xe-Math.abs(xe-xs)/100, ym-Math.abs(xe-xs)/100);
            g2.drawString(toFrame.getXparameter(), xe-Math.abs(xe-xs)/20, ym+Math.abs(ye-ys)/20);
            g2.drawLine(xm, ys, xm-Math.abs(xe-xs)/100, ys+Math.abs(xe-xs)/100);
            g2.drawLine(xm, ys, xm+Math.abs(xe-xs)/100, ys+Math.abs(xe-xs)/100);
            g2.drawString(toFrame.getYparameter(), xm-Math.abs(xe-xs)/20, ys-Math.abs(ye-ys)/40);
        }
    }
    
    public void setFrame(theFrame toFrame){
        this.toFrame=toFrame;
    }
    
    public double getMin(double[] vals){
        double min=vals[0];
        for(int i=0;i<vals.length;i++){
            if(min>vals[i]){min=vals[i];}
        }
        return min;
    }
    
    public double getMax(double[] vals){
        double max=vals[0];
        for(int i=0;i<vals.length;i++){
            if(max<vals[i]){max=vals[i];}
        }
        return max;
    }
    
    private int mirrorX(int x){
        int mir=0;
        if(xind!=0){mir=2*xm-x;}else if(xind==0 && yind!=0){mir=2*xs-x;}else if(xind==0 && yind==0){mir=2*xs-x;}
        return mir;
    }

}
